<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use App\Models\groupsModel;
class groupsController extends Controller
{
    //

    public function storeGroups(Request $request){

        $validator = Validator::make($request->all(), [
            "UserId"=>["required","String"],
            "FCM"=>["required","String"],
            "GroupName"=>["required","String"],
            "GroupLink"=>["required","String"],
            "category"=>["required","String"],
            "Time"=>["required","String"],
            "Views",
            "ImageLink"=>["required","String"],
            "status",
            "country",
            "reason",
        ]);
      if($validator->fails()){  
        $responseCode=400;
    $result= array(  "Status"=>"Failed","message"=>"Something went wrong","data"=>$validator->errors()->first());
    
return response()->json($result, $responseCode);

    }else{

$exist=groupsModel::where("GroupLink",$request->GroupLink)->first();
if( $exist ){
    $responseCode=400;
    $result= array(  "Status"=>"Failed","message"=>"Group Already Exist","data"=>null);
    
return response()->json($result, $responseCode);

}else{
    $group = groupsModel::create([

        "UserId"=>$request->UserId,
        "FCM"=>$request->FCM,
        "GroupName"=>$request->GroupName,
        "GroupLink"=>$request->GroupLink,
        "category"=>$request->category,
        "Time"=>$request->Time,
        "Views"=>0,
        "ImgeLink"=>$request->ImageLink,
        "status"=>0,
        "country"=>$request->country,
        "reason"=>"",


    ]);


if($group){

$responseCode=200;
$result= array("status"=>"success","message"=>"Group Inserted Success","data"=>null );
return response()->json($result, $responseCode);
}

}

      
    }




    }



    public function getGroups(){

        $groups=groupsModel::limit(3)->get();

        if($groups){
            $responseCode=200;
            $result= array("status"=> "success","message"=> "data found","data"=>$groups);  
            return response()->json($result, $responseCode);
        }else{

            $responseCode=400;
            $result= array("status"=> "Failed","message"=> "no data found","data"=>$groups);  
            return response()->json($result, $responseCode);
        }

    }

    public function updateGroup(Request $request){
       $time= $request->query('time');

        $group = groupsModel::where("Time","=",$time)->first();
        if($group){
        $group->Views=$group->views+10;
            $group->save();
            $responseCode=200;
            $result= array("status"=> "success","message"=> "data Updated","data"=>$group);  
            return response()->json($result, $responseCode);
             

        }else{
            
            $responseCode=400;
            $result= array("status"=> "Failed","message"=> "no data found","data"=>null);  
            return response()->json($result, $responseCode);
        }


    }
}
